// 
// LDEF.c 								Custom List Definition Function for Lists Demonstration Program
// 
//
// The default list definition function supports the display of unstyled text only. The
// default list definition function is used by the text list (the list at the left of
// the dialog box) in the Lists demonstration program.
//
// The list at the right of the dialog box in the Lists demonstration program displays
// icons.  This custom list definition function is used by that list.
//
// 

//  includes

#include <ToolUtils.h>
#include <Lists.h>
#include <LowMem.h>

//  function prototypes

pascal void		main						(SInt16,Boolean,Rect *,Cell,SInt16,SInt16,ListHandle); 
void					doLDEFDraw			(Boolean,Rect *,Cell,SInt16,ListHandle);
void					doLDEFHighlight	(Rect *);

//  main

pascal void main(SInt16 message,Boolean selected,Rect *cellRect,Cell theCell,
								 SInt16 dataOffset,SInt16 dataLen,ListHandle theList)  
{
	switch(message)
	{
		case lDrawMsg:
			doLDEFDraw(selected,cellRect,theCell,dataLen,theList);
			break;
			
		case lHiliteMsg:
			doLDEFHighlight(cellRect);
			break;
	}
}

//  doLDEFDraw

void  doLDEFDraw(Boolean selected,Rect *cellRect,Cell theCell,SInt16 dataLen,
								 ListHandle theList)
{
	GrafPtr		oldPort;
	RgnHandle	oldClip;
	PenState	oldPenState;
	Rect			drawRect;
	PicHandle	pictureHdl;

	GetPort(&oldPort);
	SetPort((*theList)->port);

	oldClip = NewRgn();
	GetClip(oldClip);

	GetPenState(&oldPenState);
	PenNormal();
	
	EraseRect(cellRect);

	drawRect = *cellRect;

	if(dataLen == sizeof(PicHandle))
	{
		LGetCell((Ptr) &pictureHdl,&dataLen,theCell,theList);
		DrawPicture(pictureHdl,&drawRect);
	}

	if(selected)
		doLDEFHighlight(cellRect);

	SetPort(oldPort);

	SetClip(oldClip);
	DisposeRgn(oldClip);
	SetPenState(&oldPenState);
}

//  doLDEFHighlight

void  doLDEFHighlight(Rect *cellRect)
{
	UInt8	hiliteVal;

	hiliteVal = LMGetHiliteMode();
	BitClr(&hiliteVal,pHiliteBit);
	LMSetHiliteMode(hiliteVal);
	
	InvertRect(cellRect);
}

// 
