// 
// Demos.c
// 

#include "Miscellany.h"

//  global variables

NMRec												gNotificationRecord;
long												gStartingTickCount;
Boolean											gNotificationDemoInvoked;
Boolean											gNotificationInQueue;
Boolean											gInBackground;
extern WindowPtr						gWindowPtr;
extern Boolean							gColorQuickDraw;
extern ProcessSerialNumber	gProcessSerNum;

//  demosSegment

void  demosSegment(void) {}

//  doCommandPeriodAndStatusBar

void  doCommandPeriodAndStatusBar(void)
{
	DialogPtr	modalDlgPtr;
	RGBColor	barBackColour, barColour;
	SInt16		itemType;
	Handle		itemHdl;
	Rect			itemRect;
	SInt16 		a, b, c;
	Handle		soundHdl;
	Rect			theRect;
	SInt16		statusMax, statusCurrent;
	SInt32		finalTicks;
	
	EraseRect(&gWindowPtr->portRect);

	if(!(modalDlgPtr = GetNewDialog(rDialog,NULL,(WindowPtr) -1)))
		ExitToShell();

	DrawDialog(modalDlgPtr);
	SetPort(modalDlgPtr);

	if(gColorQuickDraw)
	{
		barBackColour.red		= 0xBFFF;
		barBackColour.green	= 0XBFFF;
		barBackColour.blue	= 0XFFFF;

		barColour.red		= 0x6FFF;
		barColour.green	= 0x6FFF;
		barColour.blue	= 0x6FFF;
	}

	GetDialogItem(modalDlgPtr,iUserItem,&itemType,&itemHdl,&itemRect);
	InsetRect(&itemRect,-1,-1);
	FrameRect(&itemRect);
	InsetRect(&itemRect,1,1);

	if(gColorQuickDraw)
	{
		RGBBackColor(&barBackColour);
		FillRect(&itemRect,&qd.white);
		RGBForeColor(&barColour);
	}

	SetPort(gWindowPtr);

	statusMax = 2184;
	statusCurrent = 0;

	for(a=0;a<8;a++)
	{
		if(doCheckForCommandPeriod() == true)
		{
			soundHdl = GetResource('snd ',rBarkSound);
			SndPlay(NULL,(SndListHandle) soundHdl,false);
			ReleaseResource(soundHdl);
			DisposeDialog(modalDlgPtr);

			SetPort(gWindowPtr);
			EraseRect(&gWindowPtr->portRect);
			MoveTo(115,110);
			ForeColor(blackColor);
			DrawString("\pOperation cancelled at user request");

			return;
		}
		for(b=12;b<373;b+=18)
		{
			for(c=8;c<232;c+=18)
			{
				SetRect(&theRect,b+a,c+a,b+16-a,c+16-a);
				if(a < 3)								 ForeColor(redColor);
				else if(a > 2 && a < 6)  ForeColor(greenColor);
				else if(a > 5)					 ForeColor(blueColor);
				FrameRect(&theRect);
				
				doDrawStatusBar(modalDlgPtr,itemRect,statusCurrent ++,statusMax);
			}
			Delay(2,&finalTicks);
		}
	}

	DisposeDialog(modalDlgPtr);	
	EraseRect(&gWindowPtr->portRect);
	MoveTo(150,110);
	ForeColor(blackColor);
	DrawString("\pOperation completed");
}

//  doDrawStatusBar

void  doDrawStatusBar(DialogPtr modalDlgPtr,Rect barRect,SInt16 statusCurrent,
											SInt16 statusMax)
{
	SInt16	barMaxWidth;
	float		barRequiredWidth;
	
	SetPort(modalDlgPtr);

	barMaxWidth = barRect.right - barRect.left;
	barRequiredWidth = ((float) statusCurrent * (float) barMaxWidth) / statusMax;
	barRect.right = barRect.left + (SInt16) barRequiredWidth;

	if(gColorQuickDraw)
		FillRect(&barRect,&qd.black);
	else	
		FillRect(&barRect,&qd.gray);

	SetPort(gWindowPtr);
}

//  doCheckForCommandPeriod

Boolean  doCheckForCommandPeriod(void)
{
	Boolean		foundCommandPeriod;
	QHdrPtr		eventQHdrPtr;
	EvQElPtr	eventQElPtr;
	long			keyCode;
	long			commandKeyDown;

	foundCommandPeriod = false;

	eventQHdrPtr = LMGetEventQueue();
	eventQElPtr = (EvQElPtr) eventQHdrPtr->qHead;

	while(eventQElPtr && !foundCommandPeriod)
	{
		if(eventQElPtr->evtQWhat == keyDown)
		{
			keyCode = eventQElPtr->evtQMessage & keyCodeMask;
			keyCode = keyCode >> 8;

			commandKeyDown = eventQElPtr->evtQModifiers & cmdKey;

			if(commandKeyDown)
				if(keyCode == 0x2f)
					foundCommandPeriod = true;
		}

		if(!foundCommandPeriod)
			eventQElPtr = (EvQElPtr) eventQElPtr->qLink;
	}

	return(foundCommandPeriod);
}

//  doSetUpNotification

void  doSetUpNotification(void)
{
	doPrepareNotificationRecord();
	gNotificationDemoInvoked = true;

	gStartingTickCount = TickCount();

	MoveTo(12,100);
	DrawString("\pPlease click on the desktop now to make the Finder ");
	DrawString("\pthe frontmost application.");
	MoveTo(42,120);
	DrawString("\p(This application will post a notification 10 seconds from now.)");
}

//  doPrepareNotificationRecord

void  doPrepareNotificationRecord(void)
{
	Handle				iconSuiteHdl;
	Handle				soundHdl;
	StringHandle	stringHdl;

	GetIconSuite(&iconSuiteHdl,rIconFamily,svAllSmallData);
	soundHdl = GetResource('snd ',rBarkSound);
	stringHdl = GetString(rString);

	gNotificationRecord.qType		 = nmType;
	gNotificationRecord.nmMark	 = 1;
	gNotificationRecord.nmIcon	 = iconSuiteHdl;
	gNotificationRecord.nmSound	 = soundHdl;
	gNotificationRecord.nmStr		 = *stringHdl;
	gNotificationRecord.nmResp	 = NULL;
	gNotificationRecord.nmRefCon = 0;
}

//  doNullEvent

void  doNullEvent(void)
{
	ProcessSerialNumber	frontProcessSerNum;
	Boolean							isSameProcess;

	if(gNotificationDemoInvoked)
	{
		if(TickCount() > gStartingTickCount + 600)
		{
			GetFrontProcess(&frontProcessSerNum);
			SameProcess(&frontProcessSerNum,&gProcessSerNum,&isSameProcess);
			if(!isSameProcess)
			{
				NMInstall(&gNotificationRecord);
				gNotificationDemoInvoked = false;
				gNotificationInQueue = true;
			}
			else
			{
				doDisplayMessageToUser();
				gNotificationDemoInvoked = false;
			}

			EraseRect(&gWindowPtr->portRect);
		}
	}
}

//  doOSEvent

void	doOSEvent(EventRecord *eventRecPtr)
{
	switch((eventRecPtr->message >> 24) & 0x000000FF)
	{
		case suspendResumeMessage:
			gInBackground = (eventRecPtr->message & resumeFlag) == 0;
			if((!gInBackground) && gNotificationInQueue)
				doDisplayMessageToUser();
			break;

		case mouseMovedMessage:
			break;
	}
}

//  doDisplayMessageToUser

void  doDisplayMessageToUser(void)
{
	if(gNotificationInQueue)
	{
		NMRemove(&gNotificationRecord);
		gNotificationInQueue = false;
	}

	NoteAlert(rAlert,NULL);

	DisposeIconSuite(gNotificationRecord.nmIcon,false);
	ReleaseResource(gNotificationRecord.nmSound);
	ReleaseResource((Handle) gNotificationRecord.nmStr);
}

//  doColourPicker

void  doColourPicker(void)
{
	RGBColor	inColour, outColour, blackColour;
	Rect			theRect;
	Point			where;
	Str255		prompt = "\pChoose a rectangle colour:";
	Boolean		okButton;
	char			*cString;

	EraseRect(&gWindowPtr->portRect);

	inColour.red		= 0xFFFF;
	inColour.green	= 0x0000;
	inColour.blue		= 0x0000;

	blackColour.red		= 0x0000;
	blackColour.green	= 0x0000;
	blackColour.blue	= 0x0000;

	theRect = gWindowPtr->portRect;
	InsetRect(&theRect,50,50);
	RGBForeColor(&inColour);
	FillRect(&theRect,&qd.black);

	where.v = 0;
	where.h = 0;

	okButton = GetColor(where,prompt,&inColour,&outColour);

	if(okButton)
	{
		RGBForeColor(&outColour);
		FillRect(&theRect,&qd.black);
		RGBForeColor(&blackColour);

		MoveTo(50,20);
		DrawString("\pRed Value: ");
		cString = doDecimalToHexadecimal(outColour.red);
		MoveTo(115,20);
		DrawText(cString,0,6);

		MoveTo(50,33);
		DrawString("\pGreen Value: ");
		cString = doDecimalToHexadecimal(outColour.green);
		MoveTo(115,33);
		DrawText(cString,0,6);

		MoveTo(50,46);
		DrawString("\pBlue Value: ");
		cString = doDecimalToHexadecimal(outColour.blue);
		MoveTo(115,46);
		DrawText(cString,0,6);
	}
	else
	{
		RGBForeColor(&inColour);
		FillRect(&theRect,&qd.black);
		RGBForeColor(&blackColour);
		MoveTo(75,125);
		DrawString("\pCancel button was clicked.  Rectangle remains red.");
	}
}

//  doDecimalToHexadecimal

char  *doDecimalToHexadecimal(UInt16 decimalNumber)
{
	static char cString[] = "0xXXXX";
	char 			  *hexCharas = "0123456789ABCDEF";
	SInt16			a;

	for (a=0;a<4;decimalNumber >>= 4,++a)
		cString[5 - a] = hexCharas[decimalNumber & 0xF];

	return cString;
}

//  doCheckSlotVInstallAvailable

Boolean  doCheckSlotVInstallAvailable(void)
{
	return trapAvailable(_SlotVInstall);
}

//  trapAvailable

Boolean  trapAvailable(SInt16 theTrap)
{
	TrapType	trapType;
	SInt16		trapMask = 0x0800;
	SInt16		numToolboxTraps;

	if((theTrap & trapMask) > 0)
		trapType = ToolTrap;
	else
		trapType = OSTrap;

	if(trapType == ToolTrap)
		theTrap = theTrap & 0x07FF;

	if(NGetTrapAddress(_InitGraf,ToolTrap) == NGetTrapAddress(0xAA6E,ToolTrap))
		numToolboxTraps = 0x0200;
	else
		numToolboxTraps = 0x0400;

	if(theTrap >= numToolboxTraps)
		theTrap = _Unimplemented;

	return(NGetTrapAddress(theTrap,trapType) != NGetTrapAddress(_Unimplemented,ToolTrap));
}

//  doDeviceLoopDraw

pascal void  doDeviceLoopDraw(SInt16 depth,SInt16 deviceFlags,GDHandle targetDeviceHdl,
															long userData)
{
	WindowPtr windowPtr;
	Rect			theRect;
	RGBColor	oldForeColour;
	RGBColor	green	= { 0x6666, 0xFFFF, 0x6666 };
	RGBColor	red		= { 0xFFFF, 0x6666, 0x6666 };
	RGBColor	blue	= { 0x9999, 0x9999, 0xFFFF };
				
	windowPtr = (WindowPtr) userData;
	EraseRect(&windowPtr->portRect);
	
	switch(depth)
	{
		case 1:
		case 2:
			SetRect(&theRect,70,40,320,200);
			FillRect(&theRect,&qd.ltGray);
			InsetRect(&theRect,30,30);
			FillRect(&theRect,&qd.gray);
			InsetRect(&theRect,30,30);
			FillRect(&theRect,&qd.dkGray);
			break;
			
		case 4:
		case 8:
		case 16:
		case 32:
			GetForeColor(&oldForeColour);
			SetRect(&theRect,70,40,320,200);
			RGBForeColor(&green);
			PaintRect(&theRect);
			InsetRect(&theRect,30,30);
			RGBForeColor(&red);
			PaintRect(&theRect);
			InsetRect(&theRect,30,30);
			RGBForeColor(&blue);
			PaintRect(&theRect);
			RGBForeColor(&oldForeColour);			
			break;
	}
}

//  doZoomWindow

void doZoomWindowMultiMonitors(WindowPtr windowPtr,SInt16 zoomInOrOut)
{
	GrafPtr			oldPort;
	Rect				windRect, intersectRect, zoomRect;
	SInt16			titleBarHeight;
	WStateData	*winStateDataPtr;
	GDHandle		deviceHdl, zoomDeviceHdl;
	long				intersectArea, greatestArea;

	GetPort(&oldPort);
	SetPort(windowPtr);

	EraseRect(&windowPtr->portRect);

	windRect = windowPtr->portRect;
	LocalToGlobal(&topLeft(windRect));
	LocalToGlobal(&botRight(windRect));
	titleBarHeight = windRect.top - (*((WindowPeek) windowPtr)->strucRgn)->rgnBBox.top - 1;

	if(zoomInOrOut == inZoomOut)
	{
		if(!gColorQuickDraw)
		{
			zoomRect = qd.screenBits.bounds;
			zoomRect.top = zoomRect.top + LMGetMBarHeight() + titleBarHeight;
			InsetRect(&zoomRect,3,3);

			winStateDataPtr = (WStateData *) *((WindowPeek) windowPtr)->dataHandle;
			winStateDataPtr->stdState = zoomRect;
		}
		else
		{
			windRect.top = windRect.top - titleBarHeight;

			deviceHdl = LMGetDeviceList();
			greatestArea = 0;

			while(deviceHdl != NULL)
			{
				if(TestDeviceAttribute(deviceHdl,screenDevice) && 
					 TestDeviceAttribute(deviceHdl,screenActive))
				{   
					SectRect(&windRect,&(*deviceHdl)->gdRect,&intersectRect);

					intersectArea = (long) (intersectRect.right - intersectRect.left) * 
																 (intersectRect.bottom - intersectRect.top);
					if(intersectArea > greatestArea)
					{
						greatestArea = intersectArea;
						zoomDeviceHdl = deviceHdl;
					}
						
					deviceHdl = GetNextDevice(deviceHdl);
				}
			}
			
			if(zoomDeviceHdl == LMGetMainDevice())
				titleBarHeight = titleBarHeight + LMGetMBarHeight();
			
			SetRect(&zoomRect,(*zoomDeviceHdl)->gdRect.left + 3,
												(*zoomDeviceHdl)->gdRect.top + titleBarHeight + 3,
												(*zoomDeviceHdl)->gdRect.right - 3,
												(*zoomDeviceHdl)->gdRect.bottom - 3);
			
			winStateDataPtr = (WStateData *) *((WindowPeek) windowPtr)->dataHandle;
			winStateDataPtr->stdState = zoomRect;
		}
	}

	ZoomWindow(windowPtr,zoomInOrOut,windowPtr == FrontWindow());
	doRedoWindowContent(windowPtr);
	SetPort(oldPort);
}

//  doResizeWindow

void doRedoWindowContent(WindowPtr windowPtr)
{
	// Do scroll bar and TextEdit, etc, adjustments here as appropriate.

	InvalRect(&windowPtr->portRect);
}

// // 