// 
// Main.c
// 

#include "Miscellany.h"

//  global variables

Boolean							gColorQuickDraw;
Boolean							gDone;
WindowPtr						gWindowPtr;
ProcessSerialNumber	gProcessSerNum;
Boolean							gMultiMonitorsDrawDemo = false;

//  main

void  main(void)
{
	OSErr					osErr;
	SInt32				response;
	Handle				menubarHdl;
	MenuHandle		menuHdl;
	EventRecord		eventRec;

	//  initialise managers

	doInitManagers();

	//  check for Color QuickDraw

	gColorQuickDraw = true;

	osErr = Gestalt(gestaltQuickdrawVersion,&response);
	if(response < gestalt8BitQD)
		gColorQuickDraw = false;

	//  set up menu bar and menus
	
	menubarHdl = GetNewMBar(rMenubar);
	if(menubarHdl == NULL)
		ExitToShell();
	SetMenuBar(menubarHdl);
	DrawMenuBar();

	menuHdl = GetMenuHandle(mApple);
	if(menuHdl == NULL)
		ExitToShell();
	else
		AppendResMenu(menuHdl,'DRVR');

	//  open window 

	if(gColorQuickDraw)
		gWindowPtr = GetNewCWindow(rWindow,NULL,(WindowPtr)-1);
	else
		gWindowPtr = GetNewWindow(rWindow,NULL,(WindowPtr)-1);

	if(gWindowPtr == NULL)
			ExitToShell();

	SetPort(gWindowPtr);
	TextSize(10);

	//  get process serial number of this process

	GetCurrentProcess(&gProcessSerNum);	

	//  enter eventLoop

	gDone = false;

	while(!gDone)
	{
		if(WaitNextEvent(everyEvent,&eventRec,30,NULL))
			doEvents(&eventRec);
		else
			doNullEvent();

		unloadSegments();
	}
}

//  doInitManagers

void  doInitManagers(void)
{
	MaxApplZone();
	MoreMasters();

	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(NULL);

	InitCursor();
	FlushEvents(everyEvent,0);
}

//  doEvents

void	doEvents(EventRecord *eventRecPtr)
{
	WindowPtr	windowPtr;
	SInt32		userData;

	switch(eventRecPtr->what)
	{
		case mouseDown:
			doMouseDown(eventRecPtr);
			break;

		case updateEvt:
			windowPtr = (WindowPtr) eventRecPtr->message;

			BeginUpdate(windowPtr);
			if(gMultiMonitorsDrawDemo == true)
			{
				userData = (SInt32) windowPtr;
				DeviceLoop(windowPtr->visRgn,(DeviceLoopDrawingUPP) doDeviceLoopDraw,userData,0);
			}
			EndUpdate(windowPtr);
			break;

		case osEvt:
			doOSEvent(eventRecPtr);
			HiliteMenu(0);
			break;
	}
}

//  doMouseDown

void	doMouseDown(EventRecord *eventRecPtr)
{
	SInt16		partCode;
	WindowPtr	windowPtr;

	partCode = FindWindow(eventRecPtr->where,&windowPtr);

	switch(partCode)
	{
		case inMenuBar:
			doMenuChoice(MenuSelect(eventRecPtr->where));
			break;

		case inSysWindow:
			SystemClick(eventRecPtr,windowPtr);
			break;

		case inContent:
			if(windowPtr != FrontWindow())
				SelectWindow(windowPtr);
			break;

		case inDrag:
			DragWindow(windowPtr,eventRecPtr->where,&qd.screenBits.bounds);
			break;
		
		case inZoomIn:
		case inZoomOut:
			if(TrackBox(windowPtr,eventRecPtr->where,partCode))
				doZoomWindowMultiMonitors(windowPtr,partCode);
			break;
	}
}

//  doMenuChoice

void  doMenuChoice(SInt32 menuChoice)
{
	SInt16	menuID, menuItem;
	Str255	itemName;
	SInt16	daDriverRefNum;

	menuID = HiWord(menuChoice);
	menuItem = LoWord(menuChoice);

	if(menuID == 0)
		return;

	switch(menuID)
	{
		case mApple:
			if(menuItem == iAbout)
				SysBeep(10);
			else
			{
				GetMenuItemText(GetMenuHandle(mApple),menuItem,itemName);
				daDriverRefNum = OpenDeskAcc(itemName);
			}
			break;

		case mFile:
			if(menuItem == iQuit)
				gDone = true;
			break;

		case mDemonstration:
			gMultiMonitorsDrawDemo = false;
			switch(menuItem)
			{
				case iCommandPeriod:
					doCommandPeriodAndStatusBar();
					break;

				case iNotification:
					EraseRect(&gWindowPtr->portRect);
					doSetUpNotification();
					break;

				case iColourPicker:
					doColourPicker();
					break;

				case iTrapAvailable:
					EraseRect(&gWindowPtr->portRect);
					MoveTo(150,110);
					if(doCheckSlotVInstallAvailable())
						DrawString("\pTrap is available");
					else
						DrawString("\pTrap is not available");
					break;
					
				case iMultiMonitors:
					EraseRect(&gWindowPtr->portRect);
					gMultiMonitorsDrawDemo = true;
					InvalRect(&gWindowPtr->portRect);
					break;
			}
	}

	HiliteMenu(0);
}

//  unloadSegments

void  unloadSegments(void)
{
	UnloadSeg(demosSegment);
}

// 