{ 
// LDEFPascal.p          Custom List Definition Procedure for Lists Demonstration Program
// 
//
// The default list definition procedure supports the display of unstyled text only. The
// default list definition procedure is used by the text list (the list at the left of
// the dialog box) in the Lists demonstration program.
//
// The list at the right of the dialog box in the Lists demonstration program displays
// icons.  This custom list definition procedure is used by that list.
//
//  }

unit LDEFPascal;

{  unit interface section }

interface

{  include the following Universal Interfaces }

uses

	Quickdraw, QuickdrawText, Types, Events, ToolUtils, OSUtils, Lists, LowMem;
	
{  procedure interfaces }

{$MAIN}
procedure main(message : integer; selected : Boolean; var cellRect : Rect; theCell : Cell;
						dataOffset : integer; dataLen : integer; theList : ListHandle);
								  
procedure DoLDEFDraw(selected : Boolean;  var cellRect : Rect; theCell : Cell;
						dataLen : integer; theList : ListHandle);
								 
procedure DoLDEFHighlight(var cellRect : Rect);
											
{  unit implementation section }

implementation

{  main }

procedure main(message : integer; selected : Boolean; var cellRect : Rect; theCell : Cell;
						dataOffset : integer; dataLen : integer; theList : ListHandle);

	begin
	case (message) of
		lDrawMsg:
			begin
			DoLDEFDraw(selected, cellRect, theCell, dataLen, theList);
			end;
			
		lHiliteMsg:
			begin
			DoLDEFHighlight(cellRect);
			end;
		end;
			{of case statement}
	end;
		{of procedure main}
		
{  DoLDEFDraw }

procedure DoLDEFDraw(selected : Boolean;  var cellRect : Rect; theCell : Cell;
						dataLen : integer; theList : ListHandle);
								 
	var
	oldPort : GrafPtr;
	oldClip : RgnHandle;
	oldPenState : PenState;
	drawRect : Rect;
	pictureHdl : PicHandle;

	begin
	GetPort(oldPort);
	SetPort(theList^^.port);

	oldClip := NewRgn;
	GetClip(oldClip);

	GetPenState(oldPenState);
	PenNormal;
	
	EraseRect(cellRect);

	drawRect := cellRect;

	if (dataLen = sizeof(PicHandle)) then
		begin
		LGetCell(@pictureHdl, dataLen, theCell, theList);
		DrawPicture(pictureHdl, drawRect);
		end;

	if (selected) then
		DoLDEFHighlight(cellRect);

	SetPort(oldPort);

	SetClip(oldClip);
	DisposeRgn(oldClip);
	SetPenState(oldPenState);
	end;
		{of procedure DoLDEFDraw}

{  DoLDEFHighlight }

procedure DoLDEFHighlight(var cellRect : Rect);
											
	var
	hiliteVal : ByteParameter;

	begin
	hiliteVal := LMGetHiliteMode;
	BitClr(Ptr(@hiliteVal), pHiliteBit);
	LMSetHiliteMode(hiliteVal);
	
	InvertRect(cellRect);
	end;
		{of procedure DoLDEFHighlight}

end.
	{of unit LDEFPascal}
	
{  }